structure Utils :> UTILS = struct

  type bignum = MyBigNums.bignum
  val zero = MyBigNums.zero
  val ten = MyBigNums.ten
  val times = Prob4.times
  val plus = Prob4.plus
  val minus = Prob4.minus

  val fromString = let
    fun digit c = if c = #"0"
                    then zero
                  else MyBigNums.fromList [Char.ord (c) - Char.ord #"0"]
    fun scan getc cs = let
      fun loop (comb,cs,curr) =
        case (getc (cs)) of
          NONE => SOME (curr,cs)
        | SOME (c,cs') => if (Char.isDigit (c))
      then loop (comb,cs',comb(times (curr,ten),digit (c))) else SOME (curr,cs)
    in
      case (getc (StringCvt.skipWS getc cs))
        of NONE => NONE
         | SOME (c,cs') => if (Char.isDigit (c))
                             then loop (plus,cs',digit (c))
                           else if (c = #"~")
                                  then loop (minus,cs', zero)
                           else NONE
    end
  in
    StringCvt.scanString scan
  end


end